# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::Web::Mgmt::V2016_06_01
  module Models
    #
    # Model object.
    #
    #
    class ApiConnectionDefinitionProperties

      include MsRestAzure

      # @return [String] Display name
      attr_accessor :display_name

      # @return [Array<ConnectionStatusDefinition>] Status of the connection
      attr_accessor :statuses

      # @return [Hash{String => String}] Dictionary of parameter values
      attr_accessor :parameter_values

      # @return [Hash{String => String}] Dictionary of custom parameter values
      attr_accessor :custom_parameter_values

      # @return [Hash{String => String}] Dictionary of nonsecret parameter
      # values
      attr_accessor :non_secret_parameter_values

      # @return [DateTime] Timestamp of the connection creation
      attr_accessor :created_time

      # @return [DateTime] Timestamp of last connection change
      attr_accessor :changed_time

      # @return [ApiReference]
      attr_accessor :api

      # @return [Array<ApiConnectionTestLink>] Links to test the API connection
      attr_accessor :test_links


      #
      # Mapper for ApiConnectionDefinitionProperties class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'ApiConnectionDefinition_properties',
          type: {
            name: 'Composite',
            class_name: 'ApiConnectionDefinitionProperties',
            model_properties: {
              display_name: {
                client_side_validation: true,
                required: false,
                serialized_name: 'displayName',
                type: {
                  name: 'String'
                }
              },
              statuses: {
                client_side_validation: true,
                required: false,
                serialized_name: 'statuses',
                type: {
                  name: 'Sequence',
                  element: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'ConnectionStatusDefinitionElementType',
                      type: {
                        name: 'Composite',
                        class_name: 'ConnectionStatusDefinition'
                      }
                  }
                }
              },
              parameter_values: {
                client_side_validation: true,
                required: false,
                serialized_name: 'parameterValues',
                type: {
                  name: 'Dictionary',
                  value: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'StringElementType',
                      type: {
                        name: 'String'
                      }
                  }
                }
              },
              custom_parameter_values: {
                client_side_validation: true,
                required: false,
                serialized_name: 'customParameterValues',
                type: {
                  name: 'Dictionary',
                  value: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'StringElementType',
                      type: {
                        name: 'String'
                      }
                  }
                }
              },
              non_secret_parameter_values: {
                client_side_validation: true,
                required: false,
                serialized_name: 'nonSecretParameterValues',
                type: {
                  name: 'Dictionary',
                  value: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'StringElementType',
                      type: {
                        name: 'String'
                      }
                  }
                }
              },
              created_time: {
                client_side_validation: true,
                required: false,
                serialized_name: 'createdTime',
                type: {
                  name: 'DateTime'
                }
              },
              changed_time: {
                client_side_validation: true,
                required: false,
                serialized_name: 'changedTime',
                type: {
                  name: 'DateTime'
                }
              },
              api: {
                client_side_validation: true,
                required: false,
                serialized_name: 'api',
                type: {
                  name: 'Composite',
                  class_name: 'ApiReference'
                }
              },
              test_links: {
                client_side_validation: true,
                required: false,
                serialized_name: 'testLinks',
                type: {
                  name: 'Sequence',
                  element: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'ApiConnectionTestLinkElementType',
                      type: {
                        name: 'Composite',
                        class_name: 'ApiConnectionTestLink'
                      }
                  }
                }
              }
            }
          }
        }
      end
    end
  end
end
