# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::Web::Mgmt::V2016_08_01
  module Models
    #
    # Full view of network features for an app (presently VNET integration and
    # Hybrid Connections).
    #
    class NetworkFeatures < ProxyOnlyResource

      include MsRestAzure

      # @return [String] The Virtual Network name.
      attr_accessor :virtual_network_name

      # @return [VnetInfo] The Virtual Network summary view.
      attr_accessor :virtual_network_connection

      # @return [Array<RelayServiceConnectionEntity>] The Hybrid Connections
      # summary view.
      attr_accessor :hybrid_connections

      # @return [Array<HybridConnection>] The Hybrid Connection V2 (Service
      # Bus) view.
      attr_accessor :hybrid_connections_v2


      #
      # Mapper for NetworkFeatures class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'NetworkFeatures',
          type: {
            name: 'Composite',
            class_name: 'NetworkFeatures',
            model_properties: {
              id: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'id',
                type: {
                  name: 'String'
                }
              },
              name: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'name',
                type: {
                  name: 'String'
                }
              },
              kind: {
                client_side_validation: true,
                required: false,
                serialized_name: 'kind',
                type: {
                  name: 'String'
                }
              },
              type: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'type',
                type: {
                  name: 'String'
                }
              },
              virtual_network_name: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.virtualNetworkName',
                type: {
                  name: 'String'
                }
              },
              virtual_network_connection: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.virtualNetworkConnection',
                type: {
                  name: 'Composite',
                  class_name: 'VnetInfo'
                }
              },
              hybrid_connections: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.hybridConnections',
                type: {
                  name: 'Sequence',
                  element: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'RelayServiceConnectionEntityElementType',
                      type: {
                        name: 'Composite',
                        class_name: 'RelayServiceConnectionEntity'
                      }
                  }
                }
              },
              hybrid_connections_v2: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.hybridConnectionsV2',
                type: {
                  name: 'Sequence',
                  element: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'HybridConnectionElementType',
                      type: {
                        name: 'Composite',
                        class_name: 'HybridConnection'
                      }
                  }
                }
              }
            }
          }
        }
      end
    end
  end
end
