# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::Web::Mgmt::V2018_02_01
  module Models
    #
    # Hybrid Connection contract. This is used to configure a Hybrid
    # Connection.
    #
    class HybridConnection < ProxyOnlyResource

      include MsRestAzure

      # @return [String] The name of the Service Bus namespace.
      attr_accessor :service_bus_namespace

      # @return [String] The name of the Service Bus relay.
      attr_accessor :relay_name

      # @return [String] The ARM URI to the Service Bus relay.
      attr_accessor :relay_arm_uri

      # @return [String] The hostname of the endpoint.
      attr_accessor :hostname

      # @return [Integer] The port of the endpoint.
      attr_accessor :port

      # @return [String] The name of the Service Bus key which has Send
      # permissions. This is used to authenticate to Service Bus.
      attr_accessor :send_key_name

      # @return [String] The value of the Service Bus key. This is used to
      # authenticate to Service Bus. In ARM this key will not be returned
      # normally, use the POST /listKeys API instead.
      attr_accessor :send_key_value

      # @return [String] The suffix for the service bus endpoint. By default
      # this is .servicebus.windows.net
      attr_accessor :service_bus_suffix


      #
      # Mapper for HybridConnection class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'HybridConnection',
          type: {
            name: 'Composite',
            class_name: 'HybridConnection',
            model_properties: {
              id: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'id',
                type: {
                  name: 'String'
                }
              },
              name: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'name',
                type: {
                  name: 'String'
                }
              },
              kind: {
                client_side_validation: true,
                required: false,
                serialized_name: 'kind',
                type: {
                  name: 'String'
                }
              },
              type: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'type',
                type: {
                  name: 'String'
                }
              },
              service_bus_namespace: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.serviceBusNamespace',
                type: {
                  name: 'String'
                }
              },
              relay_name: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.relayName',
                type: {
                  name: 'String'
                }
              },
              relay_arm_uri: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.relayArmUri',
                type: {
                  name: 'String'
                }
              },
              hostname: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.hostname',
                type: {
                  name: 'String'
                }
              },
              port: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.port',
                type: {
                  name: 'Number'
                }
              },
              send_key_name: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.sendKeyName',
                type: {
                  name: 'String'
                }
              },
              send_key_value: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.sendKeyValue',
                type: {
                  name: 'String'
                }
              },
              service_bus_suffix: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.serviceBusSuffix',
                type: {
                  name: 'String'
                }
              }
            }
          }
        }
      end
    end
  end
end
